
#ifndef EQUIVALENCECONSTRUCTOR_H
#define EQUIVALENCECONSTRUCTOR_H

#include "Petrigraph.h"
#include <vector>
#include <list>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/tree.h>

struct NodeInfo
{
	IDTYPE id;
	unsigned int level;
	unsigned int graph_id;
};

class EquivalenceConstructor {
public: 
	EquivalenceConstructor(Petrigraph & pg,
												 vector<IDTYPE> & trans,
                         vector<list<HypergraphInfo> > & m_list)
  {
		this->pg = pg;
		
		this->trans = trans;

		this->m_list = m_list;
  }

	EquivalenceConstructor()
	{
		
	}
	~EquivalenceConstructor()
	{
		
	}

   vector<list<HypergraphInfo> > construct();
//   void Write_m_list(const char *filename);
//   void Read_m_list(const char *filename);
   
  void Write_m_list(xmlNodePtr m_list_xml, vector<list<HypergraphInfo> > &m_list);
  
  void Read_m_list(xmlNodePtr m_list_xml, vector<list<HypergraphInfo> > &m_list);
   
private:

  void findAppearing();

  void optimize();

  void WriteHypergraphInfo(xmlNodePtr list_el, HypergraphInfo &hgInfo);
  
  void ReadHypergraphInfo(xmlNodePtr list_el, HypergraphInfo &hgInfo);

  void WriteHypergraph(xmlNodePtr HyperInfo, Hypergraph &hg);

  void ReadHypergraph(xmlNodePtr HyperInfo, Hypergraph &hg);
  
  xmlNodePtr GetChildrenNode(xmlNodePtr parent, char* child_name);
  
  xmlNodePtr GetNextChild(xmlNodePtr child1, char* child_name);

  unsigned int findLink(unsigned int id, unsigned int level);

  HypergraphInfo * findHypergraph(unsigned int id, unsigned int level);

  bool isLinked(unsigned int id, unsigned int level);

  // petri graph
	Petrigraph pg;

  // list of transition's ids
  vector<IDTYPE> trans;

  // [M_0] ... [M_n]
  vector<list<HypergraphInfo> > m_list;

  // equivalences and it's classes for each graph in [M_k]
  list<set<NodeInfo> > equivalences;
};

#endif
