#ifndef GTXLREADER_H
#define GTXLREADER_H

#include "GraphGrammar.h"
#include "Hypergraph.h"

#include <libxml/xmlmemory.h>
#include <libxml/parser.h>


#include <list>
#include <map>
#include <string>

using namespace std;

  // reads a file in XML GTXL (Graph Transformation System Exchange Language)
  // format and generates a GraphGrammar object from it.
class GTXLReader
  {
  public:
    GTXLReader(char *filename); 
    ~GTXLReader();
    GraphGrammar read();

    

  private:
    Hypergraph * initialGraph;
    std::list<TransformationRule *> rules;

    xmlDocPtr doc; // libxml2 document structure
    // xmlNsPtr ns;   // libxml2 namespace structure
    
    TransformationRule * readRule(xmlNodePtr node);
    Hypergraph * readHypergraph(xmlNodePtr node, std::map<std::string,IDTYPE>& xmlID2ID);
    Hypergraph * readRuleGraph(xmlNodePtr node, std::map<std::string,IDTYPE>& xmlID2ID);
    std::string getLabel(xmlNodePtr node);
    
    
private:
    string split_space(string s);
  };

#endif
