#ifndef GXLREADER_H
#define GXLREADER_H

#include "Petrigraph.h"

#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/tree.h>

class GXLReader {

public:

	GXLReader(char * approxfilename);
	~GXLReader();

	bool hasUserAttr(xmlNodePtr cur, const char* name);
	const char* getUserAttrValue(xmlNodePtr cur, const char* name, const char* type);
	void processRel(xmlNodePtr cur);
	void processNode(xmlNodePtr cur);
	Petrigraph read(long * addID);
	void setGraphGrammar(GraphGrammar gr);

private:
  xmlDocPtr doc; // libxml2 document structure

  // internal hypergraph
  Hypergraph hg;

  // Petri net
  list<PTNetTransition> transitions;
  PTMarking initial_marking;

	// grammar
	GraphGrammar ts;

	// maximal ID
	long maxID;

	// mu
	std::map<IDTYPE,std::map<IDTYPE,IDTYPE> > mu;

	// iota
	std::map<IDTYPE,IDTYPE> iota;
private:
    string split_space(string s);
};

#endif
