#include "Globals.h"
#include <assert.h>
#include <iostream>
#include <map>
#include <cstdio>

using namespace std;


  static IDTYPE lastUsedID = 1;

  /** Create a new unique ID for vertices, edges, transformation rules etc */
  IDTYPE createNewID(void)
  {
    lastUsedID++;
    /** detect overflow*/
    assert(0 < lastUsedID);
    return lastUsedID;
  }

  IDTYPE getLastID(void)
  {
		return lastUsedID;
	}
  
  void setLastID(IDTYPE id)
  {
		lastUsedID = id;
	}

  void IDTYPE2xmlID(IDTYPE id, char *ch)
  {
    sprintf(ch,"_%i",id);
  }
  
  ostream& operator<<(ostream& os, std::map<IDTYPE,IDTYPE>& m)
  {
    for(map<IDTYPE,IDTYPE>::iterator i = m.begin(); i!=m.end(); i++)
      os << (*i).first << "->" << (*i).second << "  ";
    return os;
  }
  
  bool quiet (false);
  bool debug(false);
  bool trace(false);
  bool ncov(false);
  bool nfold(false);
	bool red(true);

	bool automor(true);
	
	bool mapping(true);
  
  int depth(0);
  int unfdepth(-1);
  int maxstep(-1);

  int timeout(0);

