#ifndef GLOBALS_H
#define GLOBALS_H

#include <iostream>
#include <map>

/** Type definition for IDs of vertices, edges etc. Change to __int64 if necessary.
    * Make shure operator< is defined for IDTYPE. */
  typedef unsigned IDTYPE;

  typedef enum VERTEDGE
  {
    VERTICE = 0,
    EDGE
  } VERTEDGE;
 
  IDTYPE createNewID(void);

  IDTYPE getLastID(void);
  void setLastID(IDTYPE id);

  /** convert an IDTYPE value to an XML ID */
  void IDTYPE2xmlID(IDTYPE id, char *ch);
  
  // to print maps:
  std::ostream& operator<<(std::ostream& os, std::map<IDTYPE,IDTYPE>& m);
  
  // extern IDTYPE lastUsedID;
  
  extern bool quiet;
  extern bool debug;
  extern bool trace;
  extern bool ncov;
  extern bool nfold;
  extern bool red;

  extern bool automor;
  
  extern bool mapping;

  extern int depth;
  extern int unfdepth;
  extern int maxstep;

  extern int timeout;
  
#endif
