
#include "GraphGrammar.h"
#include <iostream>

using namespace std;

  // constructor
  GraphGrammar::GraphGrammar(Hypergraph sg)
    : startgraph(sg)
  {
  }
  // copy constructor
  GraphGrammar::GraphGrammar(const GraphGrammar& t)
    : rules(t.rules),
      startgraph(t.startgraph)
  {
    
  }

  GraphGrammar::GraphGrammar()
  {
  }
  

  IDTYPE GraphGrammar::addRule(TransformationRule rule)
  {
    rules.insert(pair<IDTYPE,TransformationRule>(rule.getID(),rule));

    return rule.getID();
    
  }

  TransformationRule& GraphGrammar::getRule(IDTYPE id)
  {
    map<IDTYPE,TransformationRule>::iterator i = rules.find(id);
    return (*i).second;
  }

  map<IDTYPE,TransformationRule>& GraphGrammar::getRules()
  {
    return rules;
  }

  Hypergraph& GraphGrammar::getStartGraph()
  {
     return startgraph;
  }

  std::ostream& operator<<(std::ostream& os, GraphGrammar& gg)
  {
    os << "GraphGrammar:\n";
    os << "StartGraph:\n" << gg.startgraph;
    os << "\nRules:\n";
    for(map<IDTYPE,TransformationRule>::iterator i = gg.rules.begin();
	i!=gg.rules.end();
	i++)
      os << (*i).second;
    return os;
  }

	/** Find a rule with a specified name */
	int GraphGrammar::findRule(std::string ruleName, bool * found)
	{
		  *found = false;
		  
		  for(std::map<IDTYPE,TransformationRule>::iterator it = rules.begin();
										it!=rules.end(); it++)
			{
				std::string s = (it->second).getName();

				// remove blanks
			  while (s.find(" ") != std::string::npos)
				  s.replace(s.find(" "), 1, "");

				if( ((it->second).getName()==ruleName) || (s==ruleName) )
				{
						*found = true;
						return it->first;
				}
			}

			return 0;
	}
