/* Content:
   TransformationSystem
*/

#ifndef TRANSFORMATIONSYSTEM
#define TRANSFORMATIONSYSTEM

#include <map>
#include <iostream>
#include "TransformationRule.h"
#include "Globals.h"

  /** Representation of a Graph Grammar */


  class GraphGrammar
  {
  public:
    GraphGrammar(Hypergraph startgraph);
    GraphGrammar(const GraphGrammar& t);
    GraphGrammar();

    IDTYPE addRule(TransformationRule rule);
    TransformationRule& getRule(IDTYPE id);
    std::map<IDTYPE,TransformationRule> &getRules();
    Hypergraph& getStartGraph();
    int findRule(std::string ruleName, bool * found);
    friend std::ostream& operator<<(std::ostream& os, GraphGrammar& gg);


  private:

    std::map<IDTYPE,TransformationRule> rules;
    Hypergraph startgraph;
  };

#endif
