
#ifndef SAMPLESTORAGE_H
#define SAMPLESTORAGE_H

#include "Petrigraph.h"
#include <vector>
#include <list>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/tree.h>

struct Sample
{
  Sample(	vector<list<HypergraphInfo> > & tree,  vector<string> & trans )
  {
		this->tree = tree;
		this->trans = trans;
  }
  Sample()
  {
  }
  
	vector<list<HypergraphInfo> > tree;
	vector<string> trans;
};

class SampleStorage
{
public: 

	SampleStorage(char * samplefile);

	~SampleStorage();

  void addSample(vector<list<HypergraphInfo> > & hi, vector<string> & trans);

  bool checkPetrigraph(Petrigraph & pg);
  
  bool checkLabels(Hypergraph & hg1, Hypergraph & hg2, map<IDTYPE, IDTYPE> & match);
  
  void WriteXML(const char *filename); 
  
  void ReadXML(const char *filename); 
  
    
private:

	list<Sample> m_list_storage;
	
	void WriteSample(xmlNodePtr list_sample, Sample &sample);
	
	void ReadSample(xmlNodePtr list_sample, Sample &sample);
	
	xmlNodePtr GetChildrenNode(xmlNodePtr parent, char* child_name);
	
  	xmlNodePtr GetNextChild(xmlNodePtr child1, char* child_name);

	
};
 


#endif
