#include "TransformationRule.h"
#include "Hypergraph.h"
#include "Globals.h"


using namespace std;

  TransformationRule::TransformationRule(Hypergraph l, Hypergraph r, const string name)
      : left(l),
	right(r),
	rulename(name)
    {
      ID = createNewID();

      // initialize depth with 0
       l.initDepth();
       r.initDepth();
   }

  TransformationRule::TransformationRule(const TransformationRule& r)
    : left(r.left),
      right(r.right),
      rulename(r.rulename),
      ID(r.ID) // exact copy; reuse ID
  {
  }
  
  
    TransformationRule::~TransformationRule()
  {
    }

    Hypergraph& TransformationRule::getLeft()
    {
      return left;
    }

    Hypergraph& TransformationRule::getRight()
    {
      return right;
    }

    IDTYPE TransformationRule::getID()
    {
      return ID;
    }

  std::string TransformationRule::getName()
  {
    return rulename;
  }

  ostream& operator<<(ostream& os, TransformationRule& tr)
  {
    os << "TransformationRule, ID=" << tr.ID << ", Name=" << tr.rulename << ":\n";
    os << "LHS:\n" << tr.left;
    os << "\nRHS:\n" << tr.right;
    os << "\n----End TransformationRule-----\n\n";
    return os;
  }





